import board, neopixel, digitalio, time, random
from analogio import AnalogIn
from audiopwmio import PWMAudioOut as AudioOut
from audiocore import WaveFile
from audiomp3 import MP3Decoder
from adafruit_led_animation.color import (
    AMBER, #(255, 100, 0)
    AQUA, # (50, 255, 255)
    BLACK, #OFF (0, 0, 0)
    BLUE, # (0, 0, 255)
    CYAN, # (0, 255, 255)
    GOLD, # (255, 222, 30)
    GREEN, # (0, 255, 0)
    JADE, # (0, 255, 40)
    MAGENTA, #(255, 0, 20)
    OLD_LACE, # (253, 245, 230)
    ORANGE, # (255, 40, 0)
    PINK, # (242, 90, 255)
    PURPLE, # (180, 0, 255)
    RED, # (255, 0, 0)
    TEAL, # (0, 255, 120)
    WHITE, # (255, 255, 255)
    YELLOW, # (255, 150, 0)
    RAINBOW # a list of colors to cycle through
    # RAINBOW is RED, ORANGE, YELLOW, GREEN, BLUE, and PURPLE ((255, 0, 0), (255, 40, 0), (255, 150, 0), (0, 255, 0), (0, 0, 255), (180, 0, 255))
)

from adafruit_led_animation.animation.chase import Chase

strip = neopixel.NeoPixel(board.A1, 30, brightness = 0.5, auto_write=True)

speaker = digitalio.DigitalInOut(board.SPEAKER_ENABLE)
speaker.direction = digitalio.Direction.OUTPUT
speaker.value = True
audio = AudioOut(board.A6)

path = "sounds/"

filename = "mysound.mp3"
filename_const = "mysound.mp3"
mp3_file = open(path + filename, "rb")
decoder = MP3Decoder(mp3_file)

def play_mp3_win(filename):
    decoder.file = open(path + filename, "rb")
    audio.play(decoder)
    while audio.playing:
        strip.fill((0,255,0))
        for i in range(0, 101):
            strip.brightness = i/100
        for i in range(100, -1, -1):
            strip.brightness = i/100
        strip.fill(BLACK)


def play_mp3_lose(filename):
    decoder.file = open(path + filename, "rb")
    audio.play(decoder)
    while audio.playing:
        strip.fill((255,0,0))
        for i in range(0, 101):
            strip.brightness = i/100
        for i in range(100, -1, -1):
            strip.brightness = i/100
        strip.fill(BLACK)



def play_mp3_level(filename):
    decoder.file = open(path + filename, "rb")
    audio.play(decoder)
    while audio.playing:
        pass

def play_mp3_victory(filename):
    decoder.file = open(path + filename, "rb")
    audio.play(decoder)
    while audio.playing:
        i = random.randint(0,29)
        x = random.randint(0,29)
        y = random.randint(0,29)
        strip[i] = YELLOW
        time.sleep(.01)
        strip[x] = GOLD
        time.sleep(.01)
        strip[y] = GREEN
        time.sleep(.01)
    strip.fill(BLACK)

counter = 0

button = digitalio.DigitalInOut(board.A4) # Wired to pin GP15
button.switch_to_input(pull=digitalio.Pull.UP)
button2 = digitalio.DigitalInOut(board.A3) # Wired to pin GP15
button2.switch_to_input(pull=digitalio.Pull.UP)

strip.fill(BLACK)

while True:
    if button2.value == False:
        play_mp3_lose("Loser.mp3")
        counter = 0
    if button.value == False: # Button is pressed when False
        counter = counter + 1
        print("Hello")
        time.sleep(0.80)
        if counter == 1:
            print(counter, "equals 1.")
            filename = "GatorChomp.mp3"
            play_mp3_level(filename)
            play_mp3_win(filename_const)
            strip.brightness = 1.0
            for i in range(5):
                strip[i] = GREEN
                time.sleep(0.2)
        if counter == 2:
            print(counter, "equals 2.")
            filename = "LogRoll.mp3"
            play_mp3_level(filename)
            play_mp3_win(filename_const)
            strip.brightness = 1.0
            for i in range(5):
                strip[i] = GREEN
            for i in range(5, 10):
                strip[i] = MAGENTA
                time.sleep(0.2)
        if counter == 3:
            print(counter, "equals 3.")
            filename = "WaterSplash.mp3"
            play_mp3_level(filename)
            play_mp3_win(filename_const)
            strip.brightness = 1.0
            for i in range(5):
                strip[i] = GREEN
            for i in range(5, 10):
                strip[i] = MAGENTA
            for i in range(10, 15):
                strip[i] = CYAN
                time.sleep(0.2)
        if counter == 4:
            print(counter, "equals 4.")
            filename = "Tiger.mp3"
            play_mp3_level(filename)
            play_mp3_win(filename_const)
            strip.brightness = 1.0
            for i in range(5):
                strip[i] = GREEN
            for i in range(5, 10):
                strip[i] = MAGENTA
            for i in range(10, 15):
                strip[i] = CYAN
            for i in range(15, 20):
                strip[i] = ORANGE
                time.sleep(0.2)
        if counter == 5:
            print(counter, "equals 5.")
            filename = "Door.mp3"
            play_mp3_level(filename)
            play_mp3_win(filename_const)
            strip.brightness = 1.0
            for i in range(5):
                strip[i] = GREEN
            for i in range(5, 10):
                strip[i] = MAGENTA
            for i in range(10, 15):
                strip[i] = CYAN
            for i in range(15, 20):
                strip[i] = ORANGE
            for i in range(20, 25):
                strip[i] = (0,0,128)
                time.sleep(0.2)
        if counter == 6:
            print(counter, "equals 6.")
            filename = "Fire.mp3"
            play_mp3_level(filename)
            play_mp3_win(filename_const)
            strip.brightness = 1.0
            for i in range(5):
                strip[i] = GREEN
            for i in range(5, 10):
                strip[i] = MAGENTA
            for i in range(10, 15):
                strip[i] = CYAN
            for i in range(15, 20):
                strip[i] = ORANGE
            for i in range(20, 25):
                strip[i] = (0,0,128)
            for i in range(25, 30):
                strip[i] = RED
                time.sleep(0.2)
        if counter > 6:
            #PLAY THIS WITH COIN AUDIO
            filename = "victory.mp3"
            play_mp3_victory(filename)
            strip.fill(BLACK)
            print("WE ARE DONE NOW.")
            counter = 0


